<template>
  <div class="m-8 mx-20">
    <div class="my-4 flex flex-col bg-white p-4 px-8 shadow-xl rounded-3xl">
      <h1 class="text-3xl mb-4">Notes</h1>
      <p class="m-2">Profile Picture: Your profile picture is stored in office365. Changes to your profile picture take effect immediately. You will need to reload "sdg people!" to see your change.</p>
      <p class="m-2">All other data:</p>
      <ol class="list-disc list-inside m-2">
        <li>Data is stored in sharepoint. Changes in sharepoint take up to 48 hours to be visible in "sdg peple!"</li>
        <li>On the sharepoint page, scroll down to find the section you wish to change.</li>
        <li>Most data is on the "Basic information" tab; and "Birthday" is found on the "Details" tab.</li>
      </ol>
      <p>The sharepoint UI is pretty ugly. We are working on a profile editing page to replace it.</p>
    </div>

    <div v-for="section in sections" :key="section.props.label" class="my-4 flex flex-col bg-white p-4 px-8 shadow-xl rounded-3xl">
      <div class="flex flex-row justify-between gap-4">
        <div>
          <Component :is="section.component" v-bind="section.props">
            <Component :is="section.slotComponent" v-bind="section.props" />
          </Component>
        </div>
        <div class="w-1/4 text-right">
          <div v-if="section.link">
            <a class="underline hover:text-sdg-blue" :href="section.link" target="_editProfile"><span v-html="section.edit" /></a>
          </div>
          <div v-else-if="section.edit">
            <a class="underline hover:text-sdg-blue" href="https://solutiondesigngroup-my.sharepoint.com/_layouts/15/editprofile.aspx" target="_editProfile">Edit: <span v-html="section.edit" /></a>
          </div>
          <div v-else>Not editable</div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import type { Person } from '@/types/Person';
import { computed } from 'vue';
import DateFormat from '@/libs/DateFormat';
import DateCategory from '../libs/DateCategory';
import AboutPersonSection from './AboutPersonSection.vue';
import SdgUserImage from './SdgUserImage.vue';

const props = defineProps<{
  person: Person;
}>();

const sdgerSince = computed(() => {
  const category = DateCategory.Categorize(props.person.employeeHireDate);
  return category.classificationString;
});

const employeeHireDate = computed(() => DateFormat.format(props.person.employeeHireDate));
const birthDate = computed(() => DateFormat.birthdate(props.person.birthday));

const sections = computed(() => [
  {
    component: AboutPersonSection,
    slotComponent: SdgUserImage,
    props: { icon: 'user-tie', label: 'Profile Picture', person: props.person, width: 100 },
    value: null,
    link: 'https://myaccount.microsoft.com/?ref=MeControl',
    edit: 'Add/Edit photo<br>(Click the photo to edit)'
  },
  {
    component: AboutPersonSection,
    props: { label: 'Name', icon: 'user-tie', value: props.person.displayName }
  },
  {
    component: AboutPersonSection,
    props: { label: 'Practice', icon: 'building', value: props.person.department }
  },
  {
    component: AboutPersonSection,
    props: { icon: 'user-tie', label: 'Title', value: props.person.jobTitle }
  },
  {
    component: AboutPersonSection,
    props: { label: 'About Me', icon: 'user', value: props.person.aboutMe },
    edit: 'About me'
  },
  {
    component: AboutPersonSection,
    props: { label: 'Ask me about', icon: 'magnifying-glass-plus', value: props.person.responsibilities },
    edit: 'Ask me about'
  },
  {
    component: AboutPersonSection,
    props: { label: "sdg'er for", icon: 'user-tie', value: `${sdgerSince.value} ${sdgerSince.value ? `(${employeeHireDate.value})` : ''}` },
    edit: 'Hire Date'
  },
  {
    component: AboutPersonSection,
    props: { label: 'Past Assignments', icon: 'building', value: props.person.pastProjects },
    edit: 'Past Projects'
  },
  {
    component: AboutPersonSection,
    props: { label: 'Skills', icon: 'user-graduate', value: props.person.skills },
    edit: 'Skills'
  },
  {
    component: AboutPersonSection,
    props: { label: 'Interests', icon: 'binoculars', value: props.person.interests },
    edit: 'Interests'
  },
  {
    component: AboutPersonSection,
    props: { label: 'Birthday', icon: 'cake-candles', value: birthDate.value },
    edit: 'Details/Birthday<br>(Click on "Details")'
  }

  // ,
  // {
  //   component: AboutPersonSection,
  //   props: { label: 'Favorite Movie', icon: 'cake-candles', value: favoriteMovie.value },
  //   edit: 'Client Details -- Favorite Movie<br>Click on "Client Details", or<br>Click "..." and then click "Client Details"'
  // }
]);
</script>
